#include <LiquidCrystal_I2C.h>

#include <dht.h>

#define dht_apin 4 //temp & humidity pin
#define atomizationPin 2
#define waterLevelSensorPower 7
#define waterLevelSensorPin A0 
#define redPin 11 
#define bluePin 10 
#define greenPin 9

LiquidCrystal_I2C lcd(0x27, 16, 2);
const byte nsum=3;
unsigned int sensorT = 0;  // variable to store the temperature value coming from the sensor
unsigned int sensorH = 0;  // variable to store the humidity value coming from the sensor
dht DHT;
int waterLevel = 0;
 
void setup(){

  pinMode(waterLevelSensorPower, OUTPUT);
  pinMode(atomizationPin, OUTPUT);

  pinMode(redPin, OUTPUT);
  pinMode(bluePin, OUTPUT);
  pinMode(greenPin, OUTPUT);
  

  digitalWrite(waterLevelSensorPower, LOW);
  Serial.begin(9600);
  delay(500);
  lcd.begin();
  lcd.backlight();
  delay(1000);
}
 
void loop(){
  
   lcd.clear();
   lcd.setCursor(0,0);// set the cursor on the first row and column
   
   int level = readWaterLevelSensor();

     for (byte i=0;i<nsum;i++){
    DHT.read11(dht_apin);
    sensorH += DHT.humidity;    
    sensorT += DHT.temperature;
  }  
  //calculate avg humidity and temp
    int avgHumidity = sensorH/nsum;
    int avgTemp = sensorT/nsum;

   Serial.print("Humidity = ");
   Serial.print(avgHumidity);
   Serial.print("%  ");
   Serial.print("temperature = ");
   Serial.print(avgTemp); 
   Serial.println("C  ");
   lcdPrint(avgHumidity,avgTemp);
   
   if(isWaterLevelOk(level)){ //do not humidify if there is not enough water as it can damage the atomizer
        if(avgHumidity < 53){ //start humidifier if humidity level is below 50%
          digitalWrite(atomizationPin, HIGH);
          delay(10000);
          digitalWrite(atomizationPin, LOW);
          }
   }
  sensorH=0;
  sensorT=0;
  delay(2000);
}

    int readWaterLevelSensor() {
      digitalWrite(waterLevelSensorPower, HIGH);  
      delay(10);              
      waterLevel = analogRead(waterLevelSensorPin);
      digitalWrite(waterLevelSensorPower, LOW); 
      Serial.print("Water level: ");
      Serial.println(waterLevel);
      return waterLevel;   
    }
    bool isWaterLevelOk(int level){
        if( level < 360){
        analogWrite(greenPin,0);
        analogWrite(bluePin, 0);
        analogWrite(redPin,255);
        return false;
      }else if( level <540){
        analogWrite(greenPin,255);
        analogWrite(bluePin, 0);
        analogWrite(redPin,0);
        return true;
      }else if(level>=540) {
        analogWrite(greenPin,0);
        analogWrite(bluePin, 255);
        analogWrite(redPin,0);
        return true;
        }
        return false;
    }

    void lcdPrint(int humidity,int temp){
     lcd.print("Humidity=");
     lcd.print(humidity);//print the humidity
     lcd.print("%");
     lcd.setCursor(0,1);//set the cursor on the second row and first column
     lcd.print("Temp=");
     lcd.print(temp);//print the temperature
     lcd.print("C");
    }
   
